//------------------------------------------------------------------------
// EJ1.CPP  -  Programa de ejemplo de programacin bajo Windows95.
// (c) 1998, Santiago Romero Iglesias AKA NoP / Compiler, Jun-1998
//------------------------------------------------------------------------
#include <windows.h>
#include <math.h>

//--- Declaracin de funciones del programa ------------------------------
int WINAPI WinMain( HINSTANCE, HINSTANCE, LPSTR, int );
LRESULT CALLBACK WndProc( HWND, UINT, WPARAM, LPARAM );


//--- Declaracin de variables del programa ------------------------------
char WindowName[]  = "Ventana de Windows";
char WindowTitle[] = "Funcin ASeno(x)";

int amplitud = 60;

//=== Funcin principal WinMain() ========================================
int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
				    LPSTR lpCmdLine, int nCmdShow )
{
	HWND hwnd;                              // handle a la ventana ppal.
	MSG msg;                                // estructura de mensaje
	WNDCLASSEX wcx;                         // estructura de la ventana

	// Definimos la estructura de clase de ventana (campos):
	wcx.cbSize = sizeof( WNDCLASSEX );      // tamao de la estructura
	wcx.style = CS_HREDRAW | CS_VREDRAW;
	wcx.lpfnWndProc = WndProc;              // funcin de ventana (Wnd)
	wcx.cbClsExtra = 0;
	wcx.cbWndExtra = 0;                     // informaciones extra
	wcx.hInstance = hInstance;              // instancia actual
	
	// icono, cursor, fondo e icono pequeo de la clase de ventana:
	wcx.hIcon = LoadIcon(NULL, IDI_WINLOGO);
	wcx.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcx.hbrBackground = (HBRUSH) GetStockObject( WHITE_BRUSH );
    wcx.hIconSm = LoadIcon(NULL, IDI_WINLOGO);

	wcx.lpszMenuName = NULL;                // nombre del men
	wcx.lpszClassName = WindowName;         // nombre de la ventana

	// Registramos la clase de ventana ya preparada:
	if( !RegisterClassEx( &wcx ) )
		return( FALSE );                    // en caso de error, salir

	// Creamos la ventana con CreateWindowEx():
	hwnd = CreateWindowEx(
		WS_EX_OVERLAPPEDWINDOW,             // estilo extendido
		WindowName,                         // nombre de la ventana
		WindowTitle,                        // ttulo de la ventana
		WS_CAPTION,                         // estilo de ventana
		CW_USEDEFAULT, CW_USEDEFAULT,       // Posicin (x,y) en pantalla
		400, 300,                           // ancho y alto de la ventana
		NULL, NULL,                         // ventana padre e hija+men
		hInstance,                          // instancia actual
		NULL                                // no hay ms informacin
		                 );

	// Comprobamos la creacin de la ventana:
	if( !hwnd )
		return( FALSE );                    // en caso de error, salir	

	// Hacemos visible la ventana y la actualizamos:
	ShowWindow( hwnd, nCmdShow );
	UpdateWindow( hwnd );

	// Bucle de mensajes, enva los mensajes hacia WndProc
	while( GetMessage( &msg, NULL, 0, 0 ) )
	{
		TranslateMessage( &msg );           // convertimos el mensaje
		DispatchMessage( &msg );            // devolvemos el control a w95
	}

	// devolvemos el valor recibido por PostQuitMessage().
	return( msg.wParam );
}


//=== Funcin del procedimiento de ventana WndProc() =====================
LRESULT CALLBACK WndProc( HWND hwnd, UINT message, 
						  WPARAM wParam, LPARAM lParam )
{
	HDC hdc;
	PAINTSTRUCT ps;
	RECT rect;
	int loop, altura;
	double radianes;

	switch( message )
	{
		// mensaje producido en la creacin de la ventana
		case WM_CREATE:
				break;

		case WM_KEYDOWN:
				switch( wParam )
				{
					case VK_ESCAPE:
					case VK_F12:
							DestroyWindow( hwnd );
							break;
					case VK_UP:
							if( amplitud < 80 )
								amplitud+=2;
							GetClientRect( hwnd, &rect );
							InvalidateRect(hwnd, &rect, TRUE);
							break;
					case VK_DOWN:
							if( amplitud > 10 )
								amplitud-=2;
							GetClientRect( hwnd, &rect );
							InvalidateRect(hwnd, &rect, TRUE);
							break;
				};
				return(0);

		case WM_PAINT:
				hdc = BeginPaint( hwnd, &ps );
				GetClientRect( hwnd, &rect );

				// dibujamos el eje horizontal
				MoveToEx(hdc, 20, 100, NULL);
				LineTo( hdc, 370, 100 );

				// dibujo de la funcin Asin(x)
				for( loop=0, radianes=0.0; loop<350; loop++ )
				{ 
					radianes = radianes + 0.04f;
					altura = (int) (((double) amplitud)*sin(radianes));
					SetPixel(hdc, 20+loop, 100+altura, RGB(0,0,200));
				}
				// mensajes de informacin
				TextOut( hdc, 8, 215, "ARRIBA/ABAJO: Modificar amplitud.", 33);
				TextOut( hdc, 8, 235, "ESCAPE/F12  : Salir del programa.", 33);
				EndPaint( hwnd, &ps );
				break;
	
		// mensaje producido al cerrar la ventana
		case WM_DESTROY:
				PostQuitMessage( 0 );
				break;

		// resto de mensajes, dar una respuesta estndar.
		default:
				return( DefWindowProc( hwnd, message, wParam, lParam ) );
	}

	return(0);
}
//=== Fin del archivo ====================================================
