//------------------------------------------------------------------------
// EJ2.CPP  -  Programa de ejemplo de programacin bajo Windows95.
// (c) 1998, Santiago Romero Iglesias AKA NoP / Compiler, Jun-1998
//------------------------------------------------------------------------
#include <windows.h>

//--- Declaracin de funciones del programa ------------------------------
int WINAPI WinMain( HINSTANCE, HINSTANCE, LPSTR, int );
LRESULT CALLBACK WndProc( HWND, UINT, WPARAM, LPARAM );


//--- Declaracin de variables del programa ------------------------------
char WindowName[]  = "Ventana de Windows";
char WindowTitle[] = "Crono";
int minutos, segundos, horas;

//=== Funcin principal WinMain() ========================================
int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
				    LPSTR lpCmdLine, int nCmdShow )
{
	HWND hwnd;                              // handle a la ventana ppal.
	MSG msg;                                // estructura de mensaje
	WNDCLASSEX wcx;                         // estructura de la ventana

	// Definimos la estructura de clase de ventana (campos):
	wcx.cbSize = sizeof( WNDCLASSEX );      // tamao de la estructura
	wcx.style = CS_HREDRAW | CS_VREDRAW;    // valores ms usuales
	wcx.lpfnWndProc = WndProc;              // funcin de ventana (Wnd)
	wcx.cbClsExtra = 0;
	wcx.cbWndExtra = 0;                     // informaciones extra
	wcx.hInstance = hInstance;              // instancia actual
	
	// icono, cursor, fondo e icono pequeo de la clase de ventana:
	wcx.hIcon = LoadIcon(NULL, IDI_WINLOGO);
	wcx.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcx.hbrBackground = (HBRUSH) GetStockObject( WHITE_BRUSH );
    wcx.hIconSm = LoadIcon(NULL, IDI_WINLOGO);

	wcx.lpszMenuName = NULL;                // nombre del men
	wcx.lpszClassName = WindowName;         // nombre de la ventana

	// Registramos la clase de ventana ya preparada:
	if( !RegisterClassEx( &wcx ) )
		return( FALSE );                    // en caso de error, salir

	// Creamos la ventana con CreateWindowEx():
	hwnd = CreateWindowEx(
		WS_EX_OVERLAPPEDWINDOW,             // estilo extendido
		WindowName,                         // nombre de la ventana
		WindowTitle,                        // ttulo de la ventana
		WS_CAPTION,                         // estilo de ventana
		CW_USEDEFAULT, CW_USEDEFAULT,       // Posicin (x,y) en pantalla
		80, 80,                             // ancho y alto de la ventana
		NULL, NULL,                         // ventana padre e hija+men
		hInstance,                          // instancia actual
		NULL                                // no hay ms informacin
		                 );

	// Comprobamos la creacin de la ventana:
	if( !hwnd )
		return( FALSE );                    // en caso de error, salir	

	// Hacemos visible la ventana y la actualizamos:
	ShowWindow( hwnd, nCmdShow );
	UpdateWindow( hwnd );

	// Bucle de mensajes, enva los mensajes hacia WndProc
	while( GetMessage( &msg, NULL, 0, 0 ) )
	{
		TranslateMessage( &msg );           // convertimos el mensaje
		DispatchMessage( &msg );            // devolvemos el control a w95
	}

	// devolvemos el valor recibido por PostQuitMessage().
	return( msg.wParam );
}


//=== Funcin del procedimiento de ventana WndProc() =====================
LRESULT CALLBACK WndProc( HWND hwnd, UINT message, 
						  WPARAM wParam, LPARAM lParam )
{
	HDC hdc;
	PAINTSTRUCT ps;
	RECT rect;
	int longitud;
	char cadena[40];

	switch( message )
	{
		// mensaje producido en la creacin de la ventana
		case WM_CREATE:
				minutos=segundos=horas=0;
				SetTimer( hwnd, 1, 1000, NULL );
				break;

		case WM_KEYDOWN:
				if( wParam == VK_ESCAPE )
					DestroyWindow( hwnd );
				return(0);

		case WM_TIMER:
				segundos++;
				if( segundos > 60 )
				{  minutos++;  segundos=0;  }
				if( minutos > 60 )
				{  horas++; minutos = 0;    }
				if( horas > 24 )
					horas = 0;

				GetClientRect( hwnd, &rect );
				InvalidateRect( hwnd, &rect, TRUE );
				break;

		case WM_PAINT:
				hdc = BeginPaint( hwnd, &ps );
				GetClientRect( hwnd, &rect );
				longitud=wsprintf(cadena, "%02d:%02d:%02d", horas,
					              minutos, segundos );
				DrawText( hdc, cadena, -1, &rect,
						  DT_SINGLELINE | DT_CENTER | DT_VCENTER );
				EndPaint( hwnd, &ps );
				break;
	
		// mensaje producido al cerrar la ventana
		case WM_DESTROY:
				KillTimer( hwnd, 1 );
				PostQuitMessage( 0 );
				break;

		// resto de mensajes, dar una respuesta estndar.
		default:
				return( DefWindowProc( hwnd, message, wParam, lParam ) );
	}

	return(0);
}

//=== Fin del archivo ====================================================
